<?php
define('IN_PHPBB', 1);
if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['Forums']['Topic_shadows'] = $filename;
	return;
}

$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
(file_exists('pagestart.' . $phpEx)) ? require('pagestart.' . $phpEx) : require('pagestart.inc');
require($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin.' . $phpEx);
include("../../../includes/functions_admin.php");

// who is the poster of the shadow
function id_to_name_topic_shadow($user_id)
{
	global $db;
	$sql = "SELECT username FROM ".USERS_TABLE." WHERE user_id = $user_id";
	if(!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, "Couldn't query users table", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	return $row['username'];
}

// resync
$sql = "SELECT f.forum_id, t.forum_id FROM ".FORUMS_TABLE." f, ".TOPICS_TABLE." t WHERE f.forum_id = t.forum_id AND t.topic_status = 2";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not get forum IDs (resync).', '', __LINE__, __FILE__, $sql);
}
$row = $db->sql_fetchrow($result);

// delete a shadow
if(isset($HTTP_GET_VARS['delete']) || isset($HTTP_POST_VARS['delete']))
{
	$delete = (isset($HTTP_GET_VARS['delete'])) ? $HTTP_GET_VARS['delete'] : $HTTP_POST_VARS['delete'];
	$sql = "DELETE FROM ".TOPICS_TABLE." WHERE topic_id = $delete";
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Unable to delete shadow.", "", __LINE__, __FILE__, $sql);
	}
	sync('forum', $row['forum_id']);
			
	$template->assign_vars(array(
	        'INFO_MESSAGE' => sprintf($lang['Deleted_topic'], $delete),
	));
}
// delete all shadows
else if(isset($HTTP_GET_VARS['all_shadows']) || isset($HTTP_POST_VARS['all_shadows']))
{
	$sql = "DELETE FROM ".TOPICS_TABLE."	WHERE topic_status = 2";
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Unable to delete shadows.", "", __LINE__, __FILE__, $sql);
	}
	sync('forum', $row['forum_id']);

	$template->assign_vars(array(
	        'INFO_MESSAGE' => $lang['Deleted_topics'],
	));
}
// delete all shadows in last week
else if(isset($HTTP_GET_VARS['lastweek']) || isset($HTTP_POST_VARS['lastweek']))
{
	$sql = "DELETE FROM ".TOPICS_TABLE."	WHERE topic_status = 2 AND UNIX_TIMESTAMP(NOW()) - topic_time > 691200";
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Unable to delete shadows.", "", __LINE__, __FILE__, $sql);
	}
	sync('forum', $row['forum_id']);

	$template->assign_vars(array(
	        'INFO_MESSAGE' => $lang['Deleted_topics_lastweek'],
	));
}

// sort order
$start = ( isset($HTTP_GET_VARS['start']) ) ? $HTTP_GET_VARS['start'] : 0;
if(isset($HTTP_POST_VARS['order']))
{
	$sort_order = ($HTTP_POST_VARS['order'] == "DESC") ? "DESC" : "ASC";
}
else if(isset($HTTP_GET_VARS['order']))
{
	$sort_order = ($HTTP_GET_VARS['order'] == "DESC") ? "DESC" : "ASC";
}
else
{
	$sort_order = "DESC";
}

// sort method
if(isset($HTTP_GET_VARS['mode']) || isset($HTTP_POST_VARS['mode']))
{
	$mode = (isset($HTTP_POST_VARS['mode'])) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
	switch($mode)
	{
		case 'date':
                		$order_by = "WHERE topic_status = 2 ORDER BY topic_time $sort_order LIMIT $start, " . $board_config['topics_per_page'];
	                	$where_by = "WHERE topic_status = 2";
                		break;
		case 'title':
                		$order_by = "WHERE topic_status = 2 ORDER BY topic_title $sort_order LIMIT $start, " . $board_config['topics_per_page'];
	                	$where_by = "WHERE topic_status = 2";
                		break;
		case 'poster':
                		$order_by = "WHERE topic_status = 2 ORDER BY topic_poster $sort_order LIMIT $start, " . $board_config['topics_per_page'];
	                	$where_by = "WHERE topic_status = 2";
                		break;
		case 'moved':
                		$order_by = "WHERE topic_status = 2 ORDER BY topic_moved_id $sort_order LIMIT $start, " . $board_config['topics_per_page'];
	                	$where_by = "WHERE topic_status = 2";
                		break;
		default:
	                	$order_by = "WHERE topic_status = 2 ORDER BY topic_time $sort_order LIMIT $start, " . $board_config['topics_per_page'];
                		$where_by = "WHERE topic_status = 2";
	                	break;
	}
}
else
{
	$order_by = "WHERE topic_status = 2 ORDER BY topic_time $sort_order LIMIT $start, " . $board_config['topics_per_page'];
	$where_by = "WHERE topic_status = 2";
}

$mode_types_text = array($lang['Date'], $lang['Title'], $lang['Poster'], $lang['Moved_to']);
$mode_types = array(date, title, poster, moved);

$select_sort_mode = "<select name=\"mode\">";
for($i = 0; $i < count($mode_types_text); $i++)
{
	$selected = ($mode == $mode_types[$i]) ? " selected=\"selected\"" : "";
	$select_sort_mode .= "<option value=\"" . $mode_types[$i] . "\"$selected>" . $mode_types_text[$i] . "</option>";
}
$select_sort_mode .= "</select>";
$select_sort_order = "<select name=\"order\">";
if($sort_order == "ASC")
{
	$select_sort_order .= "<option value=\"ASC\" selected=\"selected\">" . $lang['Sort_Ascending'] . "</option><option value=\"DESC\">" . $lang['Sort_Descending'] . "</option>";
}
else
{
	$select_sort_order .= "<option value=\"ASC\">" . $lang['Sort_Ascending'] . "</option><option value=\"DESC\" selected=\"selected\">" . $lang['Sort_Descending'] . "</option>";
}
$select_sort_order .= "</select>";

// Generate page
$template->set_filenames(array(
        'body' => "admin/admin_topic_shadow.tpl")
);

$sql = "SELECT * FROM ".TOPICS_TABLE." $order_by";
if( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Couldn't query shadows.", "", __LINE__, __FILE__, $sql);
}

$i = 0;
while ($shadows = $db->sql_fetchrow($result))
{
            $title = ( strlen($shadows['topic_title']) < 25 ) ? $shadows['topic_title'] : substr(stripslashes($shadows['topic_title']), 0, 25) . "..."; 
	$topic_id = $shadows['topic_id'];

	$moved_id = $shadows['topic_moved_id'];
	$poster = $shadows['topic_poster'];

	$date = create_date($board_config['default_dateformat'], $shadows['topic_time'], $board_config['board_timezone']);

	$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

	$template->assign_block_vars("shadows", array(
	        'ROW_CLASS' => $row_class,
	        'ROW_NUMBER' => $i + ( $HTTP_GET_VARS['start'] + 1 ),
	        'TYPE' => $type,
	        'TITLE' => $title,
	        'POSTER' => id_to_name_topic_shadow($poster),
	        'DATE' => $date,
	        'MOVED_ID' => append_sid($phpbb_root_path . "viewtopic.php?t=$moved_id"),

	        'U_DELETE' => append_sid("admin_topic_shadow.$phpEx?sort=$sort_order&mode=$mode&start=$start&delete=" . $topic_id),
	));
	$i++;
}

$sql = "SELECT count(*) AS total FROM ".TOPICS_TABLE." $where_by";
if(!$count_result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Error getting total shadows.", "", __LINE__, __FILE__, $sql);
}
else
{
	$total = $db->sql_fetchrow($count_result);
	$total_shadows = $total['total'];
	$l_total_shadows = ( $total['total'] == 1 ) ? sprintf($lang['Total_shadow'], $total_shadows) : sprintf($lang['Total_shadows'], $total_shadows);

	$pagination = generate_pagination("admin_topic_shadow.$phpEx?mode=$mode&amp;order=$sort_order", $total_shadows, $board_config['topics_per_page'], $start)."&nbsp;";
}

$sql = "SELECT * FROM ".TOPICS_TABLE." $where_by";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not get topic status.', '', __LINE__, __FILE__, $sql);
}
$row = $db->sql_fetchrow($result);
if ( $row['topic_status'] == 2 )
{
        $template->assign_block_vars('there_are_shadows', array());
}
else
{
        $template->assign_block_vars('there_are_no_shadows', array());
}

$template->assign_vars(array(
        'L_DELETE_ALL' => $lang['Delete_all'],
        'L_DELETE_LASTWEEK' => $lang['Delete_lastweek'],
        'L_SELECT_SORT_METHOD' => $lang['Select_sort_method'],
        'L_ORDER' => $lang['Order'],
        'L_SUBMIT' => $lang['Sort'],
        'L_TITLE' => $lang['Title'],
        'L_POSTER' => $lang['Poster'],
        'L_DATE' => $lang['Date'],
        'L_MOVED_TO' => $lang['Moved_to'],
        'L_DELETE' => $lang['Delete'],
        'L_GOTO_PAGE' => $lang['Goto_page'],
        'L_NO_SHADOWS' => $lang['No_shadows'],

        'S_MODE_SELECT' => $select_sort_mode,
        'S_ORDER_SELECT' => $select_sort_order,
        'S_MODE_ACTION' => append_sid("admin_topic_shadow.$phpEx"),

        'U_DELETE_ALL' => append_sid("admin_topic_shadow.$phpEx?sort=$sort_order&mode=$mode&start=$start&all_shadows=all_shadows"),
        'U_DELETE_LASTWEEK' => append_sid("admin_topic_shadow.$phpEx?sort=$sort_order&mode=$mode&start=$start&lastweek=lastweek"),

        'TOTAL' => $l_total_shadows,
        'PAGINATION' => $pagination,
        'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / $board_config['topics_per_page'] ) + 1 ), ceil( $total_shadows / $board_config['topics_per_page'] )),
));


$template->pparse("body");
include('page_footer_admin.'.$phpEx);
?>
